//*****************************************************************************
//
// bl_flash.h - Flash programming functions used by the boot loader.
//
// Copyright (c) 2006-2011 Texas Instruments Incorporated.  All rights reserved.
// Software License Agreement
// 
// Texas Instruments (TI) is supplying this software for use solely and
// exclusively on TI's microcontroller products. The software is owned by
// TI and/or its suppliers, and is protected under applicable copyright
// laws. You may not combine this software with "viral" open-source
// software in order to form a larger program.
// 
// THIS SOFTWARE IS PROVIDED "AS IS" AND WITH ALL FAULTS.
// NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT
// NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. TI SHALL NOT, UNDER ANY
// CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES, FOR ANY REASON WHATSOEVER.
// 
//
//*****************************************************************************


#ifndef __BL_FLASH_H__
#define __BL_FLASH_H__

#include "sys_common.h"


//*****************************************************************************
//
// Basic functions for erasing and programming internal flash.
//
//*****************************************************************************
extern uint32  BLInternalFlashFirstSectorSizeGet(void);
extern uint32  BLInternalFlashSizeGet(void);
extern uint32  BLInternalFlashStartAddrCheck(uint32 ulAddr, uint32 ulImgSize);

extern uint32 Fapi_BlockProgram( uint32*, uint32*, uint32);
extern uint32 Fapi_EccBlockProgram( uint32*, uint32*, uint32);
extern uint32 Fapi_BlockErase( uint32 Flash_Start_Address, uint32 Size_In_Bytes);
extern uint32 Fapi_UpdateStatusProgram( uint32*, uint32 );
extern uint32 Flash_Erase_Verify(uint32 Start_Sector, uint32 End_Sector);
extern uint32 Flash_Program_Verify(uint32*, uint32*, uint32, uint32);
extern uint32 BL_ECC_FlashSizeGet(void);
static uint8 Flash_ECC_Calc(uint32* , uint32* );
extern uint32 Fapi_ECC_BlockProgram( uint32* , uint32* , uint32);


#endif // __BL_FLASH_H__
